/*
 * Simple multi-server; very useless stuff :^)
 *
 * Coded as training for script-kiddies :pP
 *
 *      July 2002 * embyte@madlab.it
 *
 * Compile with 'gcc -o ss -lpthread ss.c' */

#include <netinet/in.h>
#include <sys/types.h>
#include <stdio.h>
#include <signal.h>
#include <string.h>
#include <syslog.h> 
#include <malloc.h>
#include <errno.h>
#include <getopt.h>
#include <pthread.h>

#define MAXLINE 4096

struct arghandler
{
   struct sockaddr_in ska;
   FILE *logfile;
   int client_sd;
   char *cmd;      /* command to execute */
};

struct userstruct
{
   char username[32];
   char password[32];
};

ushort file=0, sysl=0, std=0, login=0, cmd=0; /*check type of logging*/

void *handler(void *parameters);
void help();
void quit();

int main(int argc, char **argv)
{
   pthread_t *t1;
   FILE *logfile;
   int sd, client_sd, addlen = sizeof (struct sockaddr_in);
   struct arghandler arg;
   char logstring[4096], *LOGFILE, opt;
   int MAXCNT=20;   /* number of max connection for time*/
   unsigned int PORT;        /* default port to listen to */
   ushort check=0, uid;     /* check arg port */
   struct sockaddr_in ska;
   struct sockaddr_in ska2;

   /* catch signal and open syslog */
   signal (SIGINT, quit);
   openlog ("", LOG_PID, LOG_AUTHPRIV);
   uid = getuid();
   errno = 0;
   
   if (argc<2)
     {
	help();
	return 0;
     }
   else
     {
	while((opt=getopt(argc, argv, "p:m:f:e:lsoh"))!=-1)
	  {
	     switch (opt)
	       {
		case 'p': PORT=atoi(optarg);
		  check=1;
		  break;
		case 'm': MAXCNT=atoi(optarg);
		  break;
		case 'f':
		  LOGFILE = (char *) malloc (strlen(optarg));
		  strcpy(LOGFILE, optarg);
		  file=1;
		  break;
		case 'e':
		  arg.cmd = (char *) malloc (strlen(optarg));
		  strcpy(arg.cmd, optarg);
		  cmd=1;
		  break;
		case 'l': login=1;
		  break;
		case 's': sysl=1;
		  break;
		case 'o': std=1;
		  break;
		case 'h': help();
		  return 0;
	       }
	  }
     }

   if (!check)
     {
	help();
	printf("Error: you must specify a port to listen to with -p flag!\n\n");
	return 0;
     }

   if (sysl) syslog (LOG_NOTICE, "Your lovest creature has been runned now by uid %d", uid);

   sd = socket(AF_INET, SOCK_STREAM, 0);

   if (sd==-1)
     {
	fprintf (stderr, "socket() error : %s\n", strerror(errno));
	return -1;
     }

   bzero (&ska, sizeof(ska));
   ska.sin_port=htons(PORT);
   ska.sin_family=AF_INET;

   if( bind (sd, (struct sockaddr *) &ska, sizeof (ska))<0)
     {
	fprintf(stderr, "bind() error: %s\n", strerror(errno));
	return -1;
     }

   if ( listen (sd, MAXCNT)<0)
     {
	fprintf(stderr, "listen() error: %s\n", strerror(errno));
	return -1;
     }

   if (file)
     {
	logfile = fopen (LOGFILE, "a");
	if (logfile==NULL)
	  {
	     fprintf(stderr, "fopen() error : %s\n", strerror(errno));
	     return -1;
	  }
     }

   bzero(&logstring, 4096);
   sprintf (logstring,"ss is listening on port %d\n",PORT);
   if (std) puts(logstring);
   if (file) if(fputs(logstring, logfile)==-1) printf("error in write : %s\n", strerror(errno));
   if (sysl) syslog (LOG_NOTICE, "ss is listening on port %d",PORT);

   while (1)
     {
	client_sd = accept (sd, (struct sockaddr *) &ska2, &addlen);

	sprintf (logstring, "connection from %s : %d \n", inet_ntoa( (struct in_addr ) ska2.sin_addr), ntohs (ska2.sin_port) );
        if (std) puts(logstring);
	if (file) fputs(logstring, logfile);
	if (sysl) syslog (LOG_NOTICE, "connection from %s : %d", inet_ntoa( (struct in_addr ) ska2.sin_addr), ntohs (ska2.sin_port));

	arg.ska=ska2;
	arg.logfile=logfile;
	arg.client_sd=client_sd;
        pthread_create(t1, NULL, &handler, &arg);
     }

   /* closing file descriptor and stream */
   if (file) fclose(logfile);
   shutdown (sd, 2);
   shutdown (client_sd, 2);
   syslog(LOG_NOTICE, "corrected closed!");
   closelog();
   return 0;

}

void *handler(void *parameters)
{
   FILE *passfile;
   struct userstruct users[50];
   int found=0, n=0, i=-1;  // i is max_lines (32)
   char user[32], psw[32], recvline[4096], buffer[65], *p, *c;
   struct arghandler *argh=(struct arghandler *) parameters;
   struct sockaddr_in ska=argh->ska;
   FILE *logfile=argh->logfile;
   int client_sd=argh->client_sd;
   char *scmd=malloc(strlen(argh->cmd));
   strcpy(scmd, argh->cmd);

   /* prompt for loging */
   if (login)
     {

	if( (passfile=fopen ("userlist", "r"))==NULL)
	  if (errno)
	    {
	       printf("fopen() error : 'userlist' : %s\n", strerror(errno));
	       exit (-1);
	    }

	while(fscanf(passfile, "%s\n",buffer)!=EOF )
	  {
	     i++;
	     c=strtok(buffer,":");
	     strcpy(users[i].username,c);
	     c=strtok('\0',":");
	     strcpy(users[i].password,c);
	  }
	
	fclose(passfile);

	write (client_sd,"\nss user : ", sizeof("\nss user : "));
	n=read(client_sd, user, 32);
	user[n-2]='\0';
	write (client_sd,"ss psw : ", sizeof("ss psw : "));
	n=read(client_sd, psw, 32);
	psw[n-2]='\0';

	for (i;i>=0;i--)
	  {
	     if (strcmp(user, users[i].username)==0 && strcmp(psw, users[i].password)==0)
	       {
		  found=1;
		  break;
	       }

	  }
	
	if (!found)
	  {
	     write (client_sd, "login failed - your attempt has been logged\n", sizeof("login failed - your attempt has been logged\n"));
	     if (std) printf("%s:%d login failed with account %s:%s!", inet_ntoa( (struct in_addr) ska.sin_addr), ntohs (ska.sin_port),user,psw);
	     if (file) fprintf(logfile, "%s:%d login failed!", inet_ntoa( (struct in_addr) ska.sin_addr), ntohs (ska.sin_port));
	     if (sysl) syslog (LOG_NOTICE, "%s:%d login failed with account %s:%s!", inet_ntoa( (struct in_addr) ska.sin_addr), ntohs (ska.sin_port), user,psw);
	     shutdown(client_sd, 2);
	     return;
	  }
	
	else if (found)
	  {
	     if (std) printf("login ok with account %s:%s\n", user, psw);
	     if (file) fprintf(logfile,"login ok with account %s:%s\n", user, psw);
	     if (sysl) syslog(LOG_NOTICE, "login ok with account %s:%s", user, psw);
	  }

     }

   /* execute command */
   if (cmd)
     {
      	/* NB: this code has been ripped by netcat (hobbit@atstake.com) */

	close(0);                     // close stdin
	dup2 (client_sd, 0);          // clone socket descriptor to stdin, stdout and stderr
        dup2 (client_sd, 1);
	dup2 (client_sd, 2);
	close (client_sd);            // close socket descriptor
	p = strrchr (scmd, '/');
	if (p) p++;
	else p = scmd;
	execl(scmd, p, NULL);         // replace process image with command to execute
     }

   else
     {
	/* do nothing, log only */

	while ((n = read (client_sd, recvline, MAXLINE))>0)
	  {
	     recvline[n] = '\0';
	     if (std) printf("%s : %d -> %s", inet_ntoa( (struct in_addr) ska.sin_addr), ntohs (ska.sin_port), recvline);
	     if (file) fprintf(logfile, "%s : %d -> %s", inet_ntoa( (struct in_addr) ska.sin_addr), ntohs (ska.sin_port), recvline);
	     if (sysl) syslog(LOG_NOTICE, "%s : %d -> %s", inet_ntoa( (struct in_addr) ska.sin_addr), ntohs (ska.sin_port), recvline);
	  }

     }
   if (std) printf("Socket has close connection!\nNow listening...\n\n");
   if (file) fprintf(logfile,"Socket has close connection!\nNow listening...\n\n");
   if (sysl) syslog(LOG_NOTICE, "Client has close connection!\nNow listening...\n");

   return;
}

void help()
{
   printf("\nUsage : ./ss [-p port] [-m max] [-f file] [-e command] [-l] [-s] [-o] [-h]\n\n");
   printf(" -p  specify port to listen to\n");
   printf(" -m  specify max connection for time (default is 20)\n");
   printf(" -f  specify logging file (append mode)\n");
   printf(" -e  specify a command to execute immediatly after login\n");
   printf(" -l  ask for username and password for login (use 'userlist' file)\n");
   printf(" -s  specify syslog logging\n");
   printf(" -o  specify stdout logging (a simple print to video)\n");
   printf(" -h  print this help :-)\n\n");
}

void quit()
{
   syslog(LOG_NOTICE,"At this time i was killed with SIGINT signal :(");
   closelog();
   system("clear");
   exit(0);
}
